/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky
*/

#ifndef DEF_SOURCE_node_c 
#define DEF_SOURCE_node_c "node.c"

#include "mz.h"

t_MZ_Node_Pointer *MZ_Node_Pointer(t_MZ_Node_Pointer *s_Handle, void *s_Pointer, t_MZ_Node_Pointer **s_Reference);
t_MZ_Node_Pointer *MZ_DestroyNode_Pointer(t_MZ_Node_Pointer *s_Handle, int s_PointerFree);

/* [ Static function ] ==================================================================== */

/* [ Public function ] ==================================================================== */

/*
 s_Reference node : Last node pointer (For fast add node) - default is null
*/
t_MZ_Node_Pointer *MZ_Node_Pointer(t_MZ_Node_Pointer *s_Handle, void *s_Pointer, t_MZ_Node_Pointer **s_Reference)
{
 t_MZ_Node_Pointer *s_New, *s_Trace;
 s_New = (t_MZ_Node_Pointer *)MZ_Alloc(sizeof(t_MZ_Node_Pointer));
 if(s_New)
 {
  s_New->Next = (t_MZ_Node_Pointer *)0;
  s_New->Pointer = s_Pointer;  
  if(s_Handle)
  {
   if(s_Reference)
   {
    s_Trace = *s_Reference;
    if(s_Trace == (t_MZ_Node_Pointer *)0)s_Trace = s_Handle;
   }
   else s_Trace = s_Handle;
   while(s_Trace->Next)s_Trace = s_Trace->Next;
   s_Trace->Next = s_New;
   if(s_Reference)*(s_Reference) = s_New;
  }
  else s_Handle = s_New;
 }
 return(s_Handle);
}

t_MZ_Node_Pointer *MZ_DestroyNode_Pointer(t_MZ_Node_Pointer *s_Handle, int s_PointerFree)
{
 t_MZ_Node_Pointer *s_Back;
 if(s_PointerFree == 1)
 {
  while(s_Handle)
  {
   s_Back = s_Handle;
   s_Handle = s_Handle->Next;
   if(s_Back->Pointer)MZ_Free(s_Back->Pointer);
   MZ_Free(s_Back);
  }
 }
 else
 {
  while(s_Handle)
  {
   s_Back = s_Handle;
   s_Handle = s_Handle->Next;
   MZ_Free(s_Back);
  }
 }
 return(s_Handle);
}

#endif

/* End of source */
