/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky
*/

#ifndef DEF_SOURCE_release_c 
#define DEF_SOURCE_release_c "release.c"

#include <stdio.h>

#include "mz.h"

#ifndef DEF_MZ_RELEASE
#define DEF_MZ_RELEASE "Empty version"
#endif

int MZ_Release(void);
const char *MZ_ReleaseString(void);

/* [ Static function ] ==================================================================== */

/* [ Public function ] ==================================================================== */
int MZ_Release(void)
{
 static const char sg_MZ_Release[] = DEF_MZ_RELEASE; 
 static int sg_IsSee = 0, sg_ReleaseVersion = 0;
 if(sg_IsSee == 0)
 {
  int s_Major, s_Minor, s_Extra, s_Build;
  sg_IsSee = 1;
  if(sscanf(&sg_MZ_Release[0], "%i.%i.%i %i", &s_Major, &s_Minor, &s_Extra, &s_Build) == 4)
  {
   sg_ReleaseVersion = (s_Major << 24) | (s_Minor << 16) | (s_Extra << 8) | s_Build;
  }
 }
 return(sg_ReleaseVersion);
}

const char *MZ_ReleaseString(void)
{
 static char sg_MZ_ReleaseString[ 128 ];
 int s_Release;
 s_Release = MZ_Release();
 sprintf(&sg_MZ_ReleaseString[0], "%d.%d.%d build %d", (s_Release >> 24) & 0xff, (s_Release >> 16) & 0xff, (s_Release >> 8) & 0xff, (s_Release & 0xff));
 return((const char *)(&sg_MZ_ReleaseString[0]));
}

#endif

/* End of source */
