/*
 Copyright (c) Information Equipment co.,LTD.
 All right reserved.
 
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.com> Made in KOREA

 http://minzkn.pe.ky

 - Only release up working ! This is not library code !
*/

#ifndef DEF_SOURCE_releaseup_c 
#define DEF_SOURCE_releaseup_c "releaseup.c"

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

int main(int s_Argc, char *s_Argv[]);
void __WriteReleaseInfo__(const char *s_ReleaseInfoFile, int s_Release);

int main(int s_Argc, char *s_Argv[])
{
 int s_Handle, s_Length, s_Major, s_Minor, s_Extra, s_Build, s_Release;
 char *s_ReleaseInfoFile = "ReleaseInfo";
 char s_VersionBuffer[ 1024 ];
 if(s_Argc > 1)s_ReleaseInfoFile = s_Argv[1];
 s_Handle = open(s_ReleaseInfoFile, O_RDONLY);
 if(s_Handle >= 0)
 {
  s_Length = read(s_Handle, &s_VersionBuffer[0], sizeof(s_VersionBuffer) - 1);
  s_VersionBuffer[s_Length] = '\0';
  close(s_Handle);
  if(s_Length > 0)
  {
   if(sscanf(&s_VersionBuffer[0], "%i.%i.%i %i", &s_Major, &s_Minor, &s_Extra, &s_Build) == 4)
   {
    s_Release  = (s_Major & 0xff) << 24;
    s_Release |= (s_Minor & 0xff) << 16;
    s_Release |= (s_Extra & 0xff) << 8;
    s_Release |= (s_Build & 0xff);
    __WriteReleaseInfo__(s_ReleaseInfoFile, s_Release + 1); 
   }
   else fprintf(stderr, "ERROR: Can not release-up \"%s\" (Invalid field format) !\n", s_ReleaseInfoFile);
  }
  else fprintf(stderr, "ERROR: Can not release-up \"%s\" (Read size zero) !\n", s_ReleaseInfoFile);
 }
 else 
 {
  fprintf(stderr, "ERROR: Can not found \"%s\" !\n", s_ReleaseInfoFile);
  if(s_Argc <= 1)__WriteReleaseInfo__(s_ReleaseInfoFile, 0);
 }
 return(0);
}

void __WriteReleaseInfo__(const char *s_ReleaseInfoFile, int s_Release)
{
 int s_Handle, s_Length;
 char s_VersionBuffer[ 1024 ];
 sprintf(&s_VersionBuffer[0], "%d.%d.%d %d", ((s_Release >> 24) & 0xff), ((s_Release >> 16) & 0xff), ((s_Release >> 8) & 0xff), s_Release & 0xff);
 s_Handle = open(s_ReleaseInfoFile, O_CREAT | O_WRONLY | O_TRUNC, 0644);
 if(s_Handle >= 0)
 {
  s_Length = strlen(s_VersionBuffer);
  if(write(s_Handle, s_VersionBuffer, s_Length) != s_Length)s_Length = 0; 
  close(s_Handle);
  if(s_Length == 0)
  {
   unlink(s_ReleaseInfoFile);
   fprintf(stderr, "ERROR: Can not write \"%s\" !\n", s_ReleaseInfoFile);
  }
  else fprintf(stdout, "MESSAGE: Create \"%s\".\n", s_ReleaseInfoFile);
 }
 else fprintf(stderr, "ERROR: Can not create \"%s\" !\n", s_ReleaseInfoFile);
}

#endif

/* End of source */
