#
# Copyright (c) Information Equipment co.,LTD.
#
# File : mzstartup.c
# Code : JaeHyuk Cho <minzkn@infoeq.co.kr>
# Date : 2002.12.23 MON 

.code32

.globl mzstartup

.globl MZ_StringLength

.globl MZ_SYSTEMCALL_Read
.globl MZ_SYSTEMCALL_Write
.globl MZ_SYSTEMCALL_Open
.globl MZ_SYSTEMCALL_Close

.globl MZ_Puts
.globl MZ_ZeroMemory
.globl MZ_CopyMemory

.extern main

.org 0x0000
mzstartup:
               movl %esp, %ebp
               leal 0x0004(%ebp), %eax
               pushl %eax
               pushl (%ebp)
               call main
               addl $4+4, %esp
               movl %eax, %ebx
               movl $1, %eax
               int $0x80

MZ_StringLength:
               pushl %ebp
               movl %esp, %ebp
               pushl %ebx
               xorl %eax, %eax
1:
               movl 8(%ebp), %ebx
               addl %eax, %ebx
               inc %eax
               cmpb $0, (%ebx)                  
               jnz 1b
               decl %eax
               popl %ebx
               popl %ebp
               ret

MZ_SYSTEMCALL_Read:
               pushl %ebp
               movl %esp, %ebp
               pushl %ebx
               pushl %ecx
               movl $3, %eax
               jmp __CommonCode           

MZ_SYSTEMCALL_Write:
               pushl %ebp
               movl %esp, %ebp
               pushl %ebx
               pushl %ecx
               movl $4, %eax
               jmp __CommonCode           

MZ_SYSTEMCALL_Open:
               pushl %ebp
               movl %esp, %ebp
               pushl %ebx
               pushl %ecx
               movl $5, %eax
               jmp __CommonCode           

MZ_SYSTEMCALL_Close:
               pushl %ebp
               movl %esp, %ebp
               pushl %ebx
               movl $6, %eax
               movl 0x0008(%ebp), %ebx
               int $0x80
               popl %ebx
               popl %ebp
               ret

__CommonCode:
               movl 0x0008(%ebp), %ebx
               movl 0x000c(%ebp), %ecx
               movl 0x0010(%ebp), %edx
               int $0x80
               popl %ecx
               popl %ebx
               popl %ebp
               ret

MZ_Puts:
               pushl %ebp
               movl %esp, %ebp
               pushl 8(%ebp)
               call MZ_StringLength
               pushl %eax
               pushl 8(%ebp)
               pushl $1
               call MZ_SYSTEMCALL_Write
               addl $(4 + 4 + 4 + 4), %esp
               pop %ebp
               ret

MZ_ZeroMemory:
               pushl %ebp
               movl %esp, %ebp
               pushl %ecx
               pushl %edi
               movl 0x0008(%ebp), %edi
               xorl %eax, %eax
               movl 0x000c(%ebp), %ecx
               cld
               shrl $1, %ecx
               jnc 0f
               stosb
0:
               shrl $1, %ecx
               jnc 0f
               stosw
0:           
               repz stosl
               popl %edi
               popl %ecx
               popl %ebp
               ret

MZ_CopyMemory:
               pushl %ebp
               movl %esp, %ebp
               pushl %ecx
               pushl %esi
               pushl %edi
               movl 0x0008(%ebp), %edi
               movl 0x000c(%ebp), %esi
               movl 0x0010(%ebp), %ecx
               cld
               shrl $1, %ecx
               jnc 0f
               movsb
0:
               shrl $1, %ecx
               jnc 0f
               movsw
0:
               repz movsl
               popl %edi
               popl %esi
               popl %ecx
               pop %ebp
               ret

# End of source 
