/* 
  Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
  All right reserved.
*/

/*
  Master boot record
*/

/* copy.s value */
DEF_BOOT_SEG       =0x07c0
DEF_SECTOR_SIZE    =512
DEF_COPY_SEG_BOOT  =0x0060

.code16
.org 0
L_Entry:
.include "copy.s"

	/* Search active */
	movw $L_PartitionTable_Start, %si
	movw $0x0004, %cx
0:
	testb $0x80, (%si)
	js 0f
	addw $0x16, %si
	loop 0b
	/* Search extended */
	movw $1f, %si
	jmp L_Error
1:
	.string "Not found active !\r\n"
0:
	movw $5, %ax
	subw %cx, %ax
	pushw %ax
	
	movb (%si), %al
	movb %al, (L_Drive)
	callw P_ResetDisk
	callw P_GetDiskParameters
	movw $DEF_BOOT_SEG, %ax
	movw %ax, %es
	xorw %bx, %bx
	movw 8(%si), %ax
	movw 10(%si), %dx
	callw P_LBA_ReadSector	

	callw P_ResetDisk

	movw $L_Message_00, %si
	callw P_Print
	popw %ax
	callw P_PrintDigit
	movw $L_Message_01, %si
	callw P_Print

	callw P_UserCode

	ljmp $DEF_BOOT_SEG, $0x0000

L_Message_00:
	.string "Boot partition "
L_Message_01:
	.string " selected.\r\n"

.include "print.s"
.include "keyboard.s"
.include "disk.s"
.include "error.s"

.align 4
	.long 0x97022744
P_UserCode:

	retw

.org 0x01be
L_PartitionTable_Start:
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /* Partition #1 */
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /* Partition #2 */
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /* Partition #3 */
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /* Partition #4 */
	.word 0xaa55                          /* Boot sector signature word */

.global L_Entry
.end

/* End of source */
