/*
 Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
 All right reserved.
*/

#ifndef __DEF_SOURCE_merge_c__
#define __DEF_SOURCE_merge_c__ "merge.c"

#define _FILE_OFFSET_BITS (64)
#define _LARGEFILE_SOURCE (1)
#define _LARGEFILE64_SOURCE (1)

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

int main(int s_Argc, char *s_Argv[]);

int main(int s_Argc, char *s_Argv[])
{
 int s_Result, s_wHandle, s_rHandle, s_ArgcIndex;
 ssize_t s_ReadBytes, s_WriteBytes;
 unsigned char s_Buffer[ 32 << 10 ];

 if(s_Argc < 3)
 {
  fprintf(stdout, "Usage: merge <target bin> <bin #1> [<bin #n>...]\n");
  return(1);
 }

 if(access(s_Argv[1], R_OK) == 0)
 {
  fprintf(stdout, "Warning: Already target bin. Overwrite now ! (\"%s\")\n", s_Argv[1]);
  /* return(0); */
 }

 s_ArgcIndex = 2;
 while(s_ArgcIndex < s_Argc)
 {
  if(access(s_Argv[s_ArgcIndex], R_OK) != 0)
  {
   fprintf(stdout, "Error: Can not read ! (\"%s\")\n", s_Argv[s_ArgcIndex]);
   return(1);
  }
  s_ArgcIndex++;
 }

 s_wHandle = open(s_Argv[1], O_CREAT | O_WRONLY | O_TRUNC | O_LARGEFILE, 0755);
 if(s_wHandle == (-1))
 {
  fprintf(stdout, "Error: Can not write ! \"%s\"\n", s_Argv[1]); 
  return(1);
 }

 fprintf(stdout, "merge to \"%s\"\n", s_Argv[1]); 
 s_Result = 0;
 s_ArgcIndex = 2;
 while(s_ArgcIndex < s_Argc)
 {
  s_rHandle = open(s_Argv[s_ArgcIndex], O_RDONLY | O_LARGEFILE);
  if(s_rHandle != (-1))
  {
   fprintf(stdout, " + \"%s\"\n", s_Argv[s_ArgcIndex]);
   do
   {
    do
    {
     s_ReadBytes = read(s_rHandle, (void *)(&s_Buffer[0]), sizeof(s_Buffer));
    }while(s_ReadBytes == (-1) && errno == EINTR);
    if(s_ReadBytes > 0)
    {
     do
     {
      s_WriteBytes = write(s_wHandle, (void *)(&s_Buffer[0]), s_ReadBytes); 
     }while(s_WriteBytes == (-1) && errno == EINTR);
     if(s_WriteBytes != s_ReadBytes)
     {
      fprintf(stdout, "Error: Copy loss ! (Read/Write=%d/%d)\n", s_ReadBytes, s_WriteBytes);
      s_Result++;
     }
    }
   }while(s_ReadBytes > 0);
   (void)close(s_rHandle);
  }
  else fprintf(stdout, "Error: Can not open ! \"%s\"\n", s_Argv[s_ArgcIndex]);
  s_ArgcIndex++;
 }

 (void)close(s_wHandle);

 return(s_Result);
}

#endif

/* End of source */
