/*
 Copyright (c) 2002 Information Equipment co.,LTD.
 All Right Reserved.

 Code by JaeHyuk Cho <minzkn@infoeq.co.kr> 
*/

#if !defined(DEF_MZ_Mixer_c)
#define DEF_MZ_Mixer_c "MZ_Mixer.c"

#include <stdio.h>
#include <string.h>

#include "mixer.h"

int main(int s_Argc, char **s_Argv);

int main(int s_Argc, char **s_Argv)
{
 int s_Return = (-1);
 fprintf(stdout, "MZ_Mixer v1.0.0 - Copyright(c)InfoEQ co.,LTD - %s %s\n", __DATE__, __TIME__);
 fprintf(stdout, "Code by JaeHyuk Cho - <minzkn@infoeq.co.kr>\n\n");
 if(s_Argc > 1)
 {
  int s_Index = 0;
  int s_Left = (-1), s_Right = (-1);
  while(g_AC97_Name[s_Index])
  {
   if(strcasecmp(g_AC97_Name[s_Index], s_Argv[1]) == 0)break; 	  
   s_Index++;
  }	  
  if(g_AC97_Name[s_Index])
  {
   fprintf(stdout, "%-4s %-12s %-16s %-4s %-4s\n", "Work", "Name", "CtrlNo", "[L]", "[R]");
   fprintf(stdout, "==== =======================================\n");
   MZ_Mixer_AC97((char *)0, E_AC97_GETVOLUME, g_AC97_Index[s_Index], &s_Left, &s_Right);	  
   fprintf(stdout, "Get  %-12s 0x%014x %4d %4d\n", g_AC97_Name[s_Index], g_AC97_Index[s_Index], s_Left, s_Right);
   if(s_Argc > 2)
   {
    sscanf(s_Argv[2], "%i", &s_Left);
    s_Right = s_Left;
    if(s_Argc > 3)sscanf(s_Argv[3], "%i", &s_Right);
    fprintf(stdout, "---- ---------------------------------------\n");
    if(s_Argv[2][0] == '-' || s_Argv[2][0] == '+')
    {
     MZ_Mixer_AC97((char *)0, E_AC97_VOLUME_ADJUST, g_AC97_Index[s_Index], &s_Left, &s_Right);	  
     fprintf(stdout, "Set  %-12s 0x%014x %+4d %+4d\n", g_AC97_Name[s_Index], g_AC97_Index[s_Index], s_Left, s_Right);
    }
    else
    {
     MZ_Mixer_AC97((char *)0, E_AC97_VOLUME, g_AC97_Index[s_Index], &s_Left, &s_Right);	  
     fprintf(stdout, "Set  %-12s 0x%014x %4d %4d\n", g_AC97_Name[s_Index], g_AC97_Index[s_Index], s_Left, s_Right);
    }
    MZ_Mixer_AC97((char *)0, E_AC97_GETVOLUME, g_AC97_Index[s_Index], &s_Left, &s_Right);	  
    fprintf(stdout, "Chk  %-12s 0x%014x %4d %4d\n", g_AC97_Name[s_Index], g_AC97_Index[s_Index], s_Left, s_Right);
   }
   fprintf(stdout, "==== =======================================\n");
  }
  else
  {
   fprintf(stderr, "Unknown channel name !\n");
  }
 }
 else
 {
  int s_Index = 0;
  int s_Left, s_Right;
  fprintf(stdout, "Usage: mixer <Name> [<Left> [<Right>]]\n\n");
  fprintf(stdout, "%-12s %-16s %-3s %-3s\n", "Name", "CtrlNo", "[L]", "[R]");
  fprintf(stdout, "=====================================\n");
  while(g_AC97_Index[s_Index] != E_AC97_MIXER_NONE)
  {
   MZ_Mixer_AC97((char *)0, E_AC97_GETVOLUME, g_AC97_Index[s_Index], &s_Left, &s_Right);	  
   if(s_Left != (-1) && s_Right != (-1))fprintf(stdout, "%-12s 0x%014x %3d %3d\n", g_AC97_Name[s_Index], g_AC97_Index[s_Index], s_Left, s_Right);
   s_Index++;
  }
  fprintf(stdout, "=====================================\n");
 }
 fprintf(stdout, "\nEnd of mixer\n");
 return(s_Return);
}

#endif 

/* End of source */ 
