/*
 Copyright (c) 2002 Information Equipment co.,LTD.
 All Right Reserved.

 Code by JaeHyuk Cho <minzkn@infoeq.co.kr> 
*/

#if !defined(DEF_mixer_h)
#define DEF_mixer_h "mixer.h"

#include <linux/soundcard.h>

#if !defined(SOUND_MIXER_GPIO)
 #define SOUND_MIXER_GPIO 25
#endif

#if !defined(SOUND_MIXER_REC)
 #define SOUND_MIXER_REC 26
#endif

typedef enum
{
 /* Info */	
 E_AC97_MIXER_NRDEVICES                   = SOUND_MIXER_NRDEVICES,
 /* Get */	
 E_AC97_MIXER_GET_VOLUME                  = MIXER_READ(SOUND_MIXER_VOLUME), 
 E_AC97_MIXER_GET_BASS                    = MIXER_READ(SOUND_MIXER_BASS), 
 E_AC97_MIXER_GET_TREBLE                  = MIXER_READ(SOUND_MIXER_TREBLE), 
 E_AC97_MIXER_GET_SYNTH                   = MIXER_READ(SOUND_MIXER_SYNTH), 
 E_AC97_MIXER_GET_PCM                     = MIXER_READ(SOUND_MIXER_PCM), 
 E_AC97_MIXER_GET_SPEAKER                 = MIXER_READ(SOUND_MIXER_SPEAKER), 
 E_AC97_MIXER_GET_LINE                    = MIXER_READ(SOUND_MIXER_LINE), 
 E_AC97_MIXER_GET_MIC                     = MIXER_READ(SOUND_MIXER_MIC), 
 E_AC97_MIXER_GET_CD                      = MIXER_READ(SOUND_MIXER_CD), 
 E_AC97_MIXER_GET_IMIX                    = MIXER_READ(SOUND_MIXER_IMIX), 
 E_AC97_MIXER_GET_ALTPCM                  = MIXER_READ(SOUND_MIXER_ALTPCM), 
 E_AC97_MIXER_GET_RECLEV                  = MIXER_READ(SOUND_MIXER_RECLEV), 
 E_AC97_MIXER_GET_IGAIN                   = MIXER_READ(SOUND_MIXER_IGAIN), 
 E_AC97_MIXER_GET_OGAIN                   = MIXER_READ(SOUND_MIXER_OGAIN), 
 E_AC97_MIXER_GET_LINE1                   = MIXER_READ(SOUND_MIXER_LINE1), 
 E_AC97_MIXER_GET_LINE2                   = MIXER_READ(SOUND_MIXER_LINE2), 
 E_AC97_MIXER_GET_LINE3                   = MIXER_READ(SOUND_MIXER_LINE3), 
 E_AC97_MIXER_GET_DIGITAL1                = MIXER_READ(SOUND_MIXER_DIGITAL1), 
 E_AC97_MIXER_GET_DIGITAL2                = MIXER_READ(SOUND_MIXER_DIGITAL2), 
 E_AC97_MIXER_GET_DIGITAL3                = MIXER_READ(SOUND_MIXER_DIGITAL3), 
 E_AC97_MIXER_GET_PHONEIN                 = MIXER_READ(SOUND_MIXER_PHONEIN), 
 E_AC97_MIXER_GET_PHONEOUT                = MIXER_READ(SOUND_MIXER_PHONEOUT), 
 E_AC97_MIXER_GET_VIDEO                   = MIXER_READ(SOUND_MIXER_VIDEO), 
 E_AC97_MIXER_GET_RADIO                   = MIXER_READ(SOUND_MIXER_RADIO), 
 E_AC97_MIXER_GET_MONITOR                 = MIXER_READ(SOUND_MIXER_MONITOR), 
 E_AC97_MIXER_GET_GPIO                    = MIXER_READ(SOUND_MIXER_GPIO), 
 E_AC97_MIXER_GET_REC                     = MIXER_READ(SOUND_MIXER_REC), 
 E_AC97_MIXER_GET_ONOFF_MIN               = MIXER_READ(SOUND_ONOFF_MIN), 
 E_AC97_MIXER_GET_ONOFF_MAX               = MIXER_READ(SOUND_ONOFF_MAX), 
 E_AC97_MIXER_GET_NONE                    = MIXER_READ(SOUND_MIXER_NONE), 
 /* Set */
 E_AC97_MIXER_SET_VOLUME                  = MIXER_WRITE(SOUND_MIXER_VOLUME), 
 E_AC97_MIXER_SET_BASS                    = MIXER_WRITE(SOUND_MIXER_BASS), 
 E_AC97_MIXER_SET_TREBLE                  = MIXER_WRITE(SOUND_MIXER_TREBLE), 
 E_AC97_MIXER_SET_SYNTH                   = MIXER_WRITE(SOUND_MIXER_SYNTH), 
 E_AC97_MIXER_SET_PCM                     = MIXER_WRITE(SOUND_MIXER_PCM), 
 E_AC97_MIXER_SET_SPEAKER                 = MIXER_WRITE(SOUND_MIXER_SPEAKER), 
 E_AC97_MIXER_SET_LINE                    = MIXER_WRITE(SOUND_MIXER_LINE), 
 E_AC97_MIXER_SET_MIC                     = MIXER_WRITE(SOUND_MIXER_MIC), 
 E_AC97_MIXER_SET_CD                      = MIXER_WRITE(SOUND_MIXER_CD), 
 E_AC97_MIXER_SET_IMIX                    = MIXER_WRITE(SOUND_MIXER_IMIX), 
 E_AC97_MIXER_SET_ALTPCM                  = MIXER_WRITE(SOUND_MIXER_ALTPCM), 
 E_AC97_MIXER_SET_RECLEV                  = MIXER_WRITE(SOUND_MIXER_RECLEV), 
 E_AC97_MIXER_SET_IGAIN                   = MIXER_WRITE(SOUND_MIXER_IGAIN), 
 E_AC97_MIXER_SET_OGAIN                   = MIXER_WRITE(SOUND_MIXER_OGAIN), 
 E_AC97_MIXER_SET_LINE1                   = MIXER_WRITE(SOUND_MIXER_LINE1), 
 E_AC97_MIXER_SET_LINE2                   = MIXER_WRITE(SOUND_MIXER_LINE2), 
 E_AC97_MIXER_SET_LINE3                   = MIXER_WRITE(SOUND_MIXER_LINE3), 
 E_AC97_MIXER_SET_DIGITAL1                = MIXER_WRITE(SOUND_MIXER_DIGITAL1), 
 E_AC97_MIXER_SET_DIGITAL2                = MIXER_WRITE(SOUND_MIXER_DIGITAL2), 
 E_AC97_MIXER_SET_DIGITAL3                = MIXER_WRITE(SOUND_MIXER_DIGITAL3), 
 E_AC97_MIXER_SET_PHONEIN                 = MIXER_WRITE(SOUND_MIXER_PHONEIN), 
 E_AC97_MIXER_SET_PHONEOUT                = MIXER_WRITE(SOUND_MIXER_PHONEOUT), 
 E_AC97_MIXER_SET_VIDEO                   = MIXER_WRITE(SOUND_MIXER_VIDEO), 
 E_AC97_MIXER_SET_RADIO                   = MIXER_WRITE(SOUND_MIXER_RADIO), 
 E_AC97_MIXER_SET_MONITOR                 = MIXER_WRITE(SOUND_MIXER_MONITOR), 
 E_AC97_MIXER_SET_GPIO                    = MIXER_WRITE(SOUND_MIXER_GPIO), 
 E_AC97_MIXER_SET_REC                     = MIXER_WRITE(SOUND_MIXER_REC), 
 E_AC97_MIXER_SET_ONOFF_MIN               = MIXER_WRITE(SOUND_ONOFF_MIN), 
 E_AC97_MIXER_SET_ONOFF_MAX               = MIXER_WRITE(SOUND_ONOFF_MAX), 
 E_AC97_MIXER_SET_NONE                    = MIXER_WRITE(SOUND_MIXER_NONE), 
}e_MixerCtrl_AC97;

typedef enum
{
 E_AC97_MIXER_VOLUME                  = 0x00000001lu, 
 E_AC97_MIXER_BASS                    = 0x00000002lu, 
 E_AC97_MIXER_TREBLE                  = 0x00000004lu, 
 E_AC97_MIXER_SYNTH                   = 0x00000008lu, 
 E_AC97_MIXER_PCM                     = 0x00000010lu, 
 E_AC97_MIXER_SPEAKER                 = 0x00000020lu, 
 E_AC97_MIXER_LINE                    = 0x00000040lu, 
 E_AC97_MIXER_MIC                     = 0x00000080lu, 
 E_AC97_MIXER_CD                      = 0x00000100lu, 
 E_AC97_MIXER_IMIX                    = 0x00000200lu, 
 E_AC97_MIXER_ALTPCM                  = 0x00000400lu, 
 E_AC97_MIXER_RECLEV                  = 0x00000800lu, 
 E_AC97_MIXER_IGAIN                   = 0x00001000lu, 
 E_AC97_MIXER_OGAIN                   = 0x00002000lu, 
 E_AC97_MIXER_LINE1                   = 0x00004000lu, 
 E_AC97_MIXER_LINE2                   = 0x00008000lu, 
 E_AC97_MIXER_LINE3                   = 0x00010000lu, 
 E_AC97_MIXER_DIGITAL1                = 0x00020000lu, 
 E_AC97_MIXER_DIGITAL2                = 0x00040000lu, 
 E_AC97_MIXER_DIGITAL3                = 0x00080000lu, 
 E_AC97_MIXER_PHONEIN                 = 0x00100000lu, 
 E_AC97_MIXER_PHONEOUT                = 0x00200000lu, 
 E_AC97_MIXER_VIDEO                   = 0x00400000lu, 
 E_AC97_MIXER_RADIO                   = 0x00800000lu, 
 E_AC97_MIXER_MONITOR                 = 0x01000000lu, 
 E_AC97_MIXER_GPIO                    = 0x02000000lu, 
 E_AC97_MIXER_REC                     = 0x04000000lu, 
 E_AC97_MIXER_ONOFF_MIN               = 0x08000000lu, 
 E_AC97_MIXER_ONOFF_MAX               = 0x10000000lu, 
 E_AC97_MIXER_NONE                    = 0x00000000lu, 
}e_Mixer_AC97;

typedef enum
{
 E_AC97_MUTE_ON                       = 0x00000001lu,
 E_AC97_MUTE_OFF                      = 0x00000002lu,
 E_AC97_VOLUME                        = 0x00000004lu,
 E_AC97_VOLUME_ADJUST                 = 0x00000008lu,
 E_AC97_GETVOLUME                     = 0x00000010lu,
 E_AC97_GETMUTE                       = 0x00000020lu,
}e_MixerCmd_AC97;

typedef struct
{
 unsigned long                            Type;
 unsigned long                            GetCtrl; 
 unsigned long                            SetCtrl; 
}t_Mixer_AC97_Table;

typedef enum
{
 /*	
 E_IBOX_PCM                           = E_AC97_MIXER_PCM,
 E_IBOX_MIC1                          = E_AC97_MIXER_MIC,
 E_IBOX_MIC2                          = E_AC97_MIXER_MIC,
 E_IBOX_LINE                          = E_AC97_MIXER_LINE,
 E_IBOX_CD                            = E_AC97_MIXER_CD,
 E_IBOX_VIDEO                         = E_AC97_MIXER_VIDEO,
 E_IBOX_AUX                           = E_AC97_MIXER_LINE1,
 E_IBOX_PHONE                         = E_AC97_MIXER_PHONEIN,
 E_IBOX_BEEP                          = E_AC97_MIXER_SPEAKER,
 E_IBOX_MASTER                        = E_AC97_MIXER_VOLUME,
 E_IBOX_GPIO                          = E_AC97_MIXER_GPIO,
 E_IBOX_REC                           = E_AC97_MIXER_REC,
 E_IBOX_RECLEV                        = E_AC97_MIXER_RECLEV,
 */
 /* Product level */ 
 E_MIXER_PCM                          = E_AC97_MIXER_PCM,
 E_MIXER_SPEAKER                      = E_AC97_MIXER_SPEAKER,
 E_MIXER_TUNER                        = E_AC97_MIXER_MIC,
 E_MIXER_IN1                          = E_AC97_MIXER_LINE,
 E_MIXER_IN2                          = E_AC97_MIXER_CD,
 E_MIXER_MPEG                         = E_AC97_MIXER_VIDEO,
 E_MIXER_MASTER                       = E_AC97_MIXER_VOLUME,
 E_MIXER_GPIO                         = E_AC97_MIXER_GPIO,
}t_Mixer;

#define DEF_AC97_MIXER_TABLE(x) {E_AC97_MIXER_##x, E_AC97_MIXER_GET_##x, E_AC97_MIXER_SET_##x}

#if defined(DEF_sound_c)

#else

#if defined(__cplusplus)
extern "C"{
#endif

extern int MZ_Mixer_AC97(char *s_DeviceName, unsigned long s_Command, unsigned long s_Type, int *s_Left, int *s_Right);
extern int MZ_Index_AC97(unsigned long s_Type);
extern char *MZ_Name_AC97(unsigned long s_Type);

extern int g_AC97_Index[];
extern char *g_AC97_Name[];

#if defined(__cplusplus)
}
#endif

#endif

#endif

/* End of source */
