/*
 JaeHyuk's MP3 library example <mailto:minzkn@infoeq.com>
TODO: Mixer
*/

#include <stdio.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <linux/soundcard.h>

#include "mpg123.h"
#include "mp3_ext.h"
#include "mixer.h"

int MZ_SetupDSP(int s_Handle, int s_Channels, int s_Freq)
{
 int s_Format = AFMT_S16_NE;	
 if(ioctl(s_Handle, SNDCTL_DSP_SETFMT, &s_Format) == 0)
 {
  if(ioctl(s_Handle, SNDCTL_DSP_CHANNELS, &s_Channels) == 0)
  {
   if(ioctl(s_Handle, SNDCTL_DSP_SPEED, &s_Freq) == 0)return(1);
  }
 }
 return(-1);
}

int main(int s_Argc, char *s_Argv[])
{
 int s_Handle, s_DSP, s_ArgCount, s_ReadSize, s_PopSize, s_MyFrequency = 0, s_CurrentFrequency;
 unsigned long s_Current, s_Total;
 unsigned char s_Buffer[8 << 10];	 
 int s_LeftVolume = 67, s_RightVolume = 67;

 fprintf(stdout, "pmp3 release 0.0.9 - Code by JaeHyuk Cho <mailto:minzkn@infoeq.com>\n\n");
 
 if(s_Argc > 1)
 {
  s_ArgCount = 1;

  MZ_Mixer_AC97((char *)0 /* default /dev/mixer */, E_AC97_VOLUME, E_AC97_MIXER_VOLUME, &s_LeftVolume, &s_RightVolume);	  
  MZ_Mixer_AC97((char *)0 /* default /dev/mixer */, E_AC97_VOLUME, E_AC97_MIXER_PCM, &s_LeftVolume, &s_RightVolume);	  

  MZ_MP3_DecoderOpen();
  s_DSP = open("/dev/dsp", O_RDWR);
  if(s_DSP >= 0)
  {
L_ReLoad:;
   fprintf(stdout, "Playing \"%s\".\n", s_Argv[s_ArgCount]);	 
   s_Handle = open(s_Argv[s_ArgCount], O_RDONLY);
   if(s_Handle >= 0)
   { 
    s_Total = (unsigned long)lseek(s_Handle, 0, SEEK_END);
    s_Current = (unsigned long)lseek(s_Handle, 0, SEEK_SET);
    do
    {
     s_ReadSize = read(s_Handle, s_Buffer, sizeof(s_Buffer));
     if(s_ReadSize > 0)
     {
      s_Current += s_ReadSize;
      fprintf(stdout, "[%3lu.%02lu%%]\r", (s_Current * 100lu) / s_Total, ((s_Current * 10000lu) / s_Total) % 100lu);
      fflush(stdout);
      MZ_MP3_DecoderPush(s_Buffer, s_ReadSize);
      do
      {
       s_PopSize = MZ_MP3_DecoderPop(s_Buffer, sizeof(s_Buffer));
       if(s_PopSize > 0 && s_DSP >= 0)
       {
        s_CurrentFrequency = MZ_MP3_DecoderFrequency();
        if(s_CurrentFrequency > 0)
	{
	 if(s_MyFrequency != s_CurrentFrequency)
	 {
          s_MyFrequency = s_CurrentFrequency;		 
	  MZ_SetupDSP(s_DSP, 2, s_MyFrequency);
	  fprintf(stdout, "Change frequency : %d Hz\n", s_MyFrequency);
	 }
	}
        if(s_MyFrequency > 0)write(s_DSP, s_Buffer, s_PopSize);  /* DSP Write (PLAY PCM) */
       }
      }while(s_PopSize > 0);
     }
    }while(s_ReadSize > 0);
    close(s_Handle);
   }
   else fprintf(stderr, "Can not open file \"%s\"\n", s_Argv[1]);
   s_ArgCount++;
   if(s_ArgCount >= s_Argc)s_ArgCount = 0;
   goto L_ReLoad;
   close(s_DSP);
  }
  else fprintf(stderr, "Can not open dsp !!!\n"); 
  MZ_MP3_DecoderClose();
 }
 else fprintf(stderr, "Usage: %s [<Mp3 file> ...]\n", s_Argv[0]);
 return(0);
}

