/*
 Copyright (c) 2002 Information Equipment co.,LTD.
 All Right Reserved.

 Code by JaeHyuk Cho <minzkn@infoeq.co.kr> 

 This example !!!
   - Simple is best.

*/

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <time.h>
#include <linux/fb.h>
#include <math.h>

#define DEF_2PI (2.0 * 3.1415926)

static int                        g_FB_Handle;
static struct fb_fix_screeninfo   g_FB_FIX;
static struct fb_var_screeninfo   g_FB_VAR;
static void                      *g_FB_Map;

double MZ_ScaleFactor(double s_ToMin, double s_ToMax, double s_FromMin, double s_FromMax, double s_Current)
{
 return( (((s_ToMax - s_ToMin) * s_Current) / (s_FromMax - s_FromMin)) + s_ToMin );
}


#define DEF_WATER_GATE (g_FB_VAR.xres >> 3)
void MZ_Water(void)
{
 unsigned short s_ColorTable[DEF_WATER_GATE];	
 int s_Count, s_x, s_y, s_l, s_PlusX, s_PlusY;
 unsigned char *s_MapPtr;
 for(s_Count = 0;s_Count < DEF_WATER_GATE;s_Count++)
 {
  s_ColorTable[s_Count] = (unsigned short)(
		           sin( MZ_ScaleFactor(0.0, DEF_2PI, 0.0, DEF_WATER_GATE, (double)s_Count) ) * 16.0) + 16;
 }
 s_l = 0;
 do
 {
  s_PlusX = ((int)( sin( MZ_ScaleFactor(0.0, DEF_2PI, 0.0, DEF_WATER_GATE, (double)s_l) ) * DEF_WATER_GATE) + DEF_WATER_GATE) >> 1;
  s_PlusY = ((int)(-cos( MZ_ScaleFactor(0.0, DEF_2PI, 0.0, DEF_WATER_GATE, (double)s_l) ) * DEF_WATER_GATE) + DEF_WATER_GATE) >> 1;

  s_MapPtr = (unsigned char *)g_FB_Map;
  for(s_y = 0;s_y < g_FB_VAR.yres;s_y++)
  {
   for(s_x = 0;s_x < g_FB_VAR.xres;s_x++)
   {
    *((unsigned short *)( s_MapPtr + (s_x << 1) )) = 
              ( s_ColorTable[(s_x + s_PlusX) % DEF_WATER_GATE] + s_ColorTable[(s_y + s_PlusY) % DEF_WATER_GATE] ) >> 1;
   }
   s_MapPtr += g_FB_FIX.line_length; 
  }
  s_l++;
  if(s_l > DEF_WATER_GATE)s_l = 0; 
  /* usleep(10000); */
 }while(1);
}

int main(int s_Argc, char *s_Argv[])
{
 char *s_Device = "/dev/fb0";	
 if(s_Argc > 1)s_Device = s_Argv[1];
 printf("fbclock v1.0.1 - Code by JaeHyuk Cho <minzkn@infoeq.co.kr>\n\n");
 g_FB_Handle = open(s_Device, O_RDWR);
 if(g_FB_Handle >= 0)
 {
  if(ioctl(g_FB_Handle, FBIOGET_FSCREENINFO, &g_FB_FIX) == 0)
  {
   if(ioctl(g_FB_Handle, FBIOGET_VSCREENINFO, &g_FB_VAR) == 0)
   {
    g_FB_Map = mmap((void *)0, g_FB_FIX.line_length * g_FB_VAR.yres, PROT_READ | PROT_WRITE, MAP_SHARED, g_FB_Handle, 0);    
    if(g_FB_Map != (void *)(-1))
    { 
     MZ_Water();  
    }
    else fprintf(stderr, "Err: %d\n", __LINE__);
   }
   else fprintf(stderr, "Err: %d\n", __LINE__);
  }
  else fprintf(stderr, "Err: %d\n", __LINE__);
  close(g_FB_Handle);	 
 }
 else fprintf(stderr, "Err: %d\n", __LINE__);
 return(0);
}

/* End of source */ 
